package cells;
import java.awt.Graphics;

public class Cell extends Thread
{
    private int x, y;
    private CellularAutomatCanvas canvas;

    private boolean life;
    private int neigh = 0;

    public Cell(CellularAutomatCanvas canvas, int x, int y)
    {
        this.x = x;
        this.y = y;
        //x = canvas.getRandom(0, canvas.getWidth());
        //y = canvas.getRandom(0, canvas.getHeight());
        this.canvas = canvas;

        // determine life
        int lol = canvas.getRandom(0, 1);
        if (lol == 1) {
            life = true;
        }
        else
            life = false;
    }


    public void drawSelf(Graphics g)
    {
        if (life)
            g.fillRect(x*10, y*10, 10, 10);
        else
            g.drawRect(x * 10, y * 10, 10, 10);
    }

    private void determineLife()
    {
        if (life) {
            if (neigh < 2) life = false;
            if (neigh > 3) life = false;
        }
        else {
            if (neigh == 3) life = true;
        }
    }

    public boolean getLife()
    {
        return life;
    }

    public void setNumberOfNeighbours(int x)
    {
        neigh = x;
    }

    @Override
    public void run()
    {
        // we will wait first for everything to initialize
        try {
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }

        while (true) {
            try {
                Thread.sleep(500);
                determineLife();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

        }
    }
}
